; oU (C)GAME ARTS p
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

MDATASIZE	equ	0x3000		; ȃf[^obt@TCY
EFFECT_OFS	equ	0x0000		; ʉf[^zuItZbg
MDATA_OFS	equ	0x0200		; ȃf[^zuItZbg

start:		cli
		mov	sp,stack
		mov	bx,prgend
		shr	bx,4
		mov	ah,0x4a		; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.skip1
.halt:		hlt

.skip1:		mov	bx,MDATASIZE/16	; ȃf[^obt@TCY
		mov	ah,0x48		; [DOS] 蓖
		int	0x21
		jc	.halt
		mov	[mdataseg],ax
		mov	ds,ax
		mov	es,ax
		mov	dx,EFFECT_OFS
		mov	bx,0x0005	; ʉf[^t@Cnh
		mov	cx,0x0200	; ʉf[^TCY
		mov	ah,0x3f
		int	0x21		; ʉf[^ǂݍ
		mov	si,dx
		mov	al,0x05
		int	0x40		; ʉf[^o^(DS:SI)

		xor	ax,ax
		mov	ds,ax
		mov	cx,0x0d00
		test	byte [0x0501],0x80	; VXeNbN
		jnz	.set_timer
		mov	cx,0x1000
.set_timer:	mov	al,0x36
		out	0x77,al		; ^C}JE^ݒ
		jmp	short .next1
.next1:		jmp	short .next2
.next2:		mov	al,cl
		out	0x71,al
		jmp	short .next3
.next3:		jmp	short .next4
.next4:		mov	al,ch
		out	0x71,al
		in	al,0x02		; ^C}݂
		jmp	.next5
.next5:		and	al,0xfe
		out	0x02,al
		push	cs
		pop	ds
		mov	ax,0x2508	; ^C}݃tbN
		mov	dx,timer_int
		int	0x21

		mov	ax,0x257f	; hoothCoo^
		mov	dx,vect_7f
		int	0x21

;		sti
mainloop:	mov	ax,0x9801	; _~[|[O
		int	0x18
		jmp	short mainloop

; ^C}݃[`
;
;
timer_int:	cli
		pusha
		push	ds
		push	es
		dec	word [cs:timer_count]
		jnz	.int_end
		mov	word [cs:timer_count],0x0005	; JE^l
		int	0x41
.int_end:	mov	al,0x20		; EOIs
		out	(0x00),al
		pop	es
		pop	ds
		popa
		sti
		iret

timer_count:	dw	1

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	dx,HOOTPORT+2
		in	ax,dx
		inc	ax
		jz	.effect
		mov	al,0x01		; t~
		int	0x40
		mov	ds,[mdataseg]	; [hAhX
		mov	dx,MDATA_OFS
		xor	bx,bx		; W
		mov	cx,MDATASIZE-0x0200	; [hTCY
		mov	ah,0x3f		; ȃf[^[h (DS:DX)
		int	0x21
		jc	.ed

		push	ds		; ES=DS
		pop	es
		mov	si,MDATA_OFS
		xor	al,al		; tJn DS(ES):SI=ȃf[^AhX
		int	0x40
		jmp	short .ed

.effect:	inc	dx
		inc	dx
		in	al,dx
		xchg	cl,al
		mov	al,0x06		; ʉt CL=ʉԍ
		int	0x40
		jmp	short .ed

.stop:		mov	al,0x01		; t~
		int	0x40
		jmp	short .ed

mdataseg:	dw	0		; ȃf[^obt@ZOg

		times 0x200 db 0x00	; X^bNGA
stack:

		align	0x10
prgend:		

		ends

